com.fasterxml.jackson.databind.deser.impl

## Class ObjectIdValueProperty

- java.lang.Object
- - com.fasterxml.jackson.databind.deser.SettableBeanProperty
  - - com.fasterxml.jackson.databind.deser.impl.ObjectIdValueProperty

All Implemented Interfaces:
  BeanProperty, Named, Serializable

    public final class ObjectIdValueProperty
    extends SettableBeanProperty

Specialized `SettableBeanProperty` implementation used for virtual property that represents Object Id that is used for some POJO types (or properties).

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.BeanProperty

`BeanProperty.Std`

### Field Summary

Fields
`protected ObjectIdReader` `_objectIdReader`

### Fields inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty

`_contextAnnotations, _managedReferenceName, _metadata, _nullProvider, _objectIdInfo, _propertyIndex, _propName, _type, _valueDeserializer, _valueTypeDeserializer, _viewMatcher, _wrapperName, MISSING_VALUE_DESERIALIZER`

### Constructor Summary

Constructors
`` `ObjectIdValueProperty(ObjectIdReader objectIdReader, PropertyMetadata metadata)`
`protected` `ObjectIdValueProperty(ObjectIdValueProperty src, JsonDeserializer<?> deser)`
`protected` `ObjectIdValueProperty(ObjectIdValueProperty src, PropertyName newName)` Deprecated.
`protected` `ObjectIdValueProperty(ObjectIdValueProperty src, String newName)` Deprecated.

### Method Summary

Methods
`void` `deserializeAndSet(JsonParser jp, DeserializationContext ctxt, Object instance)` Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism.
`Object` `deserializeSetAndReturn(JsonParser jp, DeserializationContext ctxt, Object instance)` Alternative to `SettableBeanProperty.deserializeAndSet(com.fasterxml.jackson.core.JsonParser, com.fasterxml.jackson.databind.DeserializationContext, java.lang.Object)` that returns either return value of setter method called (if one is), or null to indicate that no return value is available.
`<A extends Annotation> A` `getAnnotation(Class<A> acls)` Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.
`AnnotatedMember` `getMember()` Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
`void` `set(Object instance, Object value)` Method called to assign given value to this property, on specified Object.
`Object` `setAndReturn(Object instance, Object value)` Method called to assign given value to this property, on specified Object, and return whatever delegating accessor returned (if anything)
`ObjectIdValueProperty` `withName(PropertyName newName)` Fluent factory method for constructing and returning a new instance with specified property name.
`ObjectIdValueProperty` `withValueDeserializer(JsonDeserializer<?> deser)` Fluent factory method for constructing and returning a new instance with specified value deserializer.

### Methods inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty

`_throwAsIOE, _throwAsIOE, assignIndex, depositSchemaProperty, deserialize, getContextAnnotation, getCreatorIndex, getDeclaringClass, getFullName, getInjectableValueId, getManagedReferenceName, getMetadata, getName, getObjectIdInfo, getPropertyIndex, getType, getValueDeserializer, getValueTypeDeserializer, getWrapperName, hasValueDeserializer, hasValueTypeDeserializer, hasViews, isRequired, setManagedReferenceName, setObjectIdInfo, setViews, toString, visibleInView, withName, withSimpleName`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### _objectIdReader

    protected final ObjectIdReader _objectIdReader

### Constructor Detail

#### ObjectIdValueProperty

    public ObjectIdValueProperty(ObjectIdReader objectIdReader,
                         PropertyMetadata metadata)

#### ObjectIdValueProperty

    protected ObjectIdValueProperty(ObjectIdValueProperty src,
                         JsonDeserializer<?> deser)

#### ObjectIdValueProperty

    @Deprecated
    protected ObjectIdValueProperty(ObjectIdValueProperty src,
                                    PropertyName newName)

Deprecated.

#### ObjectIdValueProperty

    @Deprecated
    protected ObjectIdValueProperty(ObjectIdValueProperty src,
                                    String newName)

Deprecated.

### Method Detail

#### withName

    public ObjectIdValueProperty withName(PropertyName newName)

Description copied from class: `SettableBeanProperty`
Fluent factory method for constructing and returning a new instance with specified property name. Note that this method should NOT change configuration of this instance.

Specified by:
  `withName` in class `SettableBeanProperty`
Parameters:
  `newName` - Name to use for the new instance.
Returns:
  Newly constructed instance, if property name differs from the one used for this instance; or 'this' if not.

#### withValueDeserializer

    public ObjectIdValueProperty withValueDeserializer(JsonDeserializer<?> deser)

Description copied from class: `SettableBeanProperty`
Fluent factory method for constructing and returning a new instance with specified value deserializer. Note that this method should NOT change configuration of this instance.

Specified by:
  `withValueDeserializer` in class `SettableBeanProperty`
Parameters:
  `deser` - Deserializer to assign to the new property instance
Returns:
  Newly constructed instance, if value deserializer differs from the one used for this instance; or 'this' if not.

#### getAnnotation

    public <A extends Annotation> A getAnnotation(Class<A> acls)

Description copied from interface: `BeanProperty`
Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.

Specified by:
  `getAnnotation` in interface `BeanProperty`
Specified by:
  `getAnnotation` in class `SettableBeanProperty`

#### getMember

    public AnnotatedMember getMember()

Description copied from interface: `BeanProperty`
Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.

Specified by:
  `getMember` in interface `BeanProperty`
Specified by:
  `getMember` in class `SettableBeanProperty`

#### deserializeAndSet

    public void deserializeAndSet(JsonParser jp,
                         DeserializationContext ctxt,
                         Object instance)
                           throws IOException

Description copied from class: `SettableBeanProperty`
Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism. Pre-condition is that passed parser must point to the first token that should be consumed to produce the value (the only value for scalars, multiple for Objects and Arrays).

Specified by:
  `deserializeAndSet` in class `SettableBeanProperty`
Throws:
  `IOException`

#### deserializeSetAndReturn

    public Object deserializeSetAndReturn(JsonParser jp,
                                 DeserializationContext ctxt,
                                 Object instance)
                                   throws IOException

Description copied from class: `SettableBeanProperty`
Alternative to `SettableBeanProperty.deserializeAndSet(com.fasterxml.jackson.core.JsonParser, com.fasterxml.jackson.databind.DeserializationContext, java.lang.Object)` that returns either return value of setter method called (if one is), or null to indicate that no return value is available. Mostly used to support Builder style deserialization.

Specified by:
  `deserializeSetAndReturn` in class `SettableBeanProperty`
Throws:
  `IOException`

#### set

    public void set(Object instance,
           Object value)
             throws IOException

Description copied from class: `SettableBeanProperty`
Method called to assign given value to this property, on specified Object.

Note: this is an optional operation, not supported by all implementations, creator-backed properties for example do not support this method.

Specified by:
  `set` in class `SettableBeanProperty`
Throws:
  `IOException`

#### setAndReturn

    public Object setAndReturn(Object instance,
                      Object value)
                        throws IOException

Description copied from class: `SettableBeanProperty`
Method called to assign given value to this property, on specified Object, and return whatever delegating accessor returned (if anything)

Note: this is an optional operation, not supported by all implementations, creator-backed properties for example do not support this method.

Specified by:
  `setAndReturn` in class `SettableBeanProperty`
Throws:
  `IOException`